# ODM abilities
execute as @s[tag=spin] run function snc:player/odm/gyro/select
execute if score odm_legacy config matches 0 run function snc:player/odm/impulse/get_direction

# Spear They can have any
execute if predicate snc:is_sneaking if predicate snc:odm/has_spear_r if score @s odm_action matches 0.. run scoreboard players set @s odm_action -30
execute if predicate snc:is_sneaking if predicate snc:odm/has_spear_l if score @s odm_action matches 0.. run scoreboard players set @s odm_action -30

# Death message
function snc:controller/check_death

execute if score @s earthquake matches 0.. run function snc:controller/earthquake/score
execute if score @s messages matches 1.. run function snc:eldian/brain/messages
execute if score @s manual matches 1.. run function snc:controller/manual/trigger
execute if score @s manual matches ..-1 run function snc:controller/manual/config

# Pure Titan
execute as @s[tag=titan] run function snc:player/titan/effects/pure
execute as @s[tag=handcuffs] unless predicate snc:is_riding run ride @s mount @e[tag=handcuffs,type=!player,sort=nearest,limit=1]

# If not shifter remove
execute unless score @s shifter_vars matches 1.. run tag @s remove injured

# Remove turret if is not Cart
execute as @s[tag=!gun,tag=clear] run function snc:shifters/mobs/cart/action/turret/clear_gun

# Boots effects
execute if block ~ ~-5 ~ air run execute unless block ~ ~-7 ~ air if predicate snc:odm/has_boots run effect give @s slow_falling 1 0 true

# kill Titan, reset each tick
execute store result score @s rot_impulse_x run data get entity @s Rotation[0]
execute store result score @s rot_impulse_y run data get entity @s Rotation[1]
execute unless predicate snc:odm/has_odm_blade run tag @s remove spin
scoreboard players set @s[tag=!spin] odm_atk_R 25
scoreboard players set @s[tag=!spin] odm_atk_L 100
execute as @s[predicate=snc:odm/has_odm_blade] run function snc:player/odm/replace_weapon/store_damage
execute as @s[predicate=snc:odm/has_spear_r] run function snc:player/odm/replace_weapon/store_right
execute as @s[predicate=snc:odm/has_spear_l] run function snc:player/odm/replace_weapon/store_left

# Using right click
execute as @s[scores={using_carrot=1..}] run function snc:player/using_carrot

# Aux impulse, see load.mcfunction for more info
execute as @s[scores={odm_state=-1}] run scoreboard players set @s odm_state 1
execute as @s[scores={odm_state=1}] unless entity @s[scores={odm_state=2..}] run scoreboard players add @s odm_push 1

execute if score @s odm_action matches 1..10 run function snc:player/odm/nape_impulse
execute if score @s odm_action matches -20..-1 run function snc:player/odm/gyro_impulse/main
execute if score @s odm_action matches -25..-21 run function snc:player/odm/gyro/main
execute if score @s odm_action matches -30..-26 run function snc:player/gun/spear/main

# Reset scan
scoreboard players remove @s[scores={man_cool=1..}] man_cool 1

execute as @s[predicate=!snc:has_gas_trigger] run scoreboard players set @s odm_state 0
execute as @s[predicate=!snc:has_gas_trigger] as @e[tag=shooter,limit=2, sort=nearest,distance=0..2] run function snc:controller/kill_mob